use warnings;
use strict;
use Test::More tests => 7;
use Test::Exception;
use Test::MockModule;

use POWER::Event::IO;


sub new_io {
    POWER::Event::IO->new({
        type        => $UDP_CONNECTED,
        host        => '127.0.0.1',
        port        => 1234,
        cb          => shift,
    });    
}

my $io;


lives_ok  { $io = new_io(sub {}) };
close $io->{fh};
throws_ok { $io = new_io(sub {}) } qr/you must do \$io->close/;
throws_ok { $io = new_io(sub {}) } qr/you must do \$io->close/;
$io->close();

my $obj = bless {}, 'main';
lives_ok  { $io = new_io($obj)   };
close $io->{fh};
throws_ok { $io = new_io(sub {}) } qr/you must do \$io->close/;
throws_ok { $io = new_io(sub {}) } qr/you must do \$io->close/;
$obj = undef;
lives_ok  { $io = new_io(sub {}) } 'AUTO close() IS WORKING!';

