use warnings;
use strict;
use Test::More tests => 4;
use Test::Exception;
use Test::MockModule;

use POWER::Event;
use POWER::Event::IO;
use POWER::Utils::IO;


POWER::Event::IO->new({
    type        => $UDP,
    fh          => udp_server('ANY', 1234),
    cb          => \&server,
    wait_for    => $IN,
});
POWER::Event::IO->new({
    type        => $UDP_CONNECTED,
    host        => '127.0.0.1',
    port        => 1234,
    cb          => \&client,
    wait_for    => $IN,
    out_buf     => 'test',
});

my @Wait = (
    ['server',      $IN         ],
    ['client',      $IN         ],
);

eval { loop() };
die "out of loop: $@";

sub server {
    my ($io) = @_;
    is_deeply(shift @Wait, ['server', $io->{events}], 'server');
    die "server unexpected event: $io->{err}" if $io->{events} != $IN;
    is(delete($io->{in_buf}), 'test', '  got "test" request');
    $io->{out_paddr} = delete $io->{in_paddr};
    $io->write('test passed');
}

sub client {
    my ($io) = @_;
    is_deeply(shift @Wait, ['client', $io->{events}], 'client');
    die "server unexpected event: $io->{err}" if $io->{events} != $IN;
    is(delete($io->{in_buf}), 'test passed', '  got "test passed" reply');
    exit;
}

